#ifndef VKAR_PHASE_FRAME_H
#define VKAR_PHASE_FRAME_H

#include <vector>
#include <iostream>
#include "Point.h"

/** A rectangular array subdivided in square pixels.
* The content of the array is a description of a 2D integer rectangular coordinate
* space. No actual data of some function of these pixels is stored.
* @author R. J. Mathar
* @since 2010-01-01
*/
class Frame {
public:
	/** Number of pixels in the x direction
	*/
	int nx ;

	/** Number of pixels in the y direction
	*/
	int ny ;

	/** Position of the origin (lower left x and lower left y coordinate)
	* on a larger canvas with more than one frame.
	*/
	Point posit ;

	Frame() ;

	Frame(int dimx, int dimy) ;

	Frame(int dimx, int dimy, const Point & pt) ;

	int area() const ;


	bool inside(const Frame & windo) const ;


	bool covers(int x, int y) const ;
protected:

private:
} ;

std::ostream & operator<<(std::ostream & os, const Frame & wd) ;

#endif /* VKAR_PHASE_FRAME_H */
