#include "PhaScr.h"

/** Ctor with the information on pixel frames and physical size.
* @param fr The arrangement of pixel frames.
* @param pscal The scale parameter, meters per pixel.
*/
template <class TYP> PhaScr<TYP>::PhaScr(const RecPixSupArr<TYP> & fr, const double pscal) 
	: RecPixSupArr<TYP>(fr), pixscal(pscal), eval(0.)
{
}


/**
* @param os
* @param fs
*/
template <class TYP> void PhaScr<TYP>::plot(std::ostream & os, const FrameSet & fs)
{
	os << "# KL eigenvalue " << eval << "\n" ;

	/* The bounding box of the frame set gives the useful index range
	*/
	int bb[4] ;
	fs.boundbox(bb) ;

	for(int x = bb[0] ; x < bb[2] ; x++)
	{
		for(int y = bb[1] ; y < bb[3] ; y++)
			os << x*pixscal << " " << y*pixscal << " " << RecPixSupArr<TYP>::at(x,y,fs) << std::endl ;
		os << std::endl ;
	}
}

/* Explicit template instantiation to prevent linkage time complaints.
*/
template class PhaScr<double> ;
template class PhaScr<float> ;
template class PhaScr<int> ;
template class PhaScr<long> ;
template class PhaScr<short> ;

