#ifndef VKAR_PHASE_RECPIXARR_H
#define VKAR_PHASE_RECPIXARR_H

#include <valarray>

/** A rectangular pixelized array with a single double value at each pixel.
* The content of the array is hardly more than a simple 2D array with
* a retrieve and store method.
* @author R. J. Mathar
* @since 2010-10-31
*/
template <class TYP> class RecPixArr {
public:
	/** Number of pixels in the x direction
	*/
	int nx ;

	/** Number of pixels in the y direction
	*/
	int ny ;

	/** The values at the positions.
	*/
	std::valarray<TYP> val ;

	RecPixArr() ;

	RecPixArr(int dimx, int dimy, TYP fvalue =0) ;

	RecPixArr(int dimx, int dimy, std::valarray<TYP> & fvalue) ;


	template <class TYPV> void set(const TYPV *fval) ;


	TYP at(int x, int y) const ;

	int area() const ;


	void clear() ;
protected:

private:
} ;
#endif /* VKAR_PHASE_RECPIXARR_H */
